<template>
  <div >
    <EmployeeForm
      v-bind.sync="employee"
      v-on:submit="submit"
      v-on:cancel="cancel"
      v-bind:loading="loading"
      v-bind:visible="visible"
      v-bind:disabled="disabled"
    >
    </EmployeeForm>
  </div>
</template>

<script>
import EmployeeForm from '@/components/employeeForm/EmployeeForm.vue';
import { getAuthenticatedUser } from '@/fb';
import { mapGetters } from 'vuex';
import Employee from '@/models/Employee';

export default {
  components: {
    EmployeeForm,
  },
  data() {
    return {
      employee: new Employee(),
      loading: false,
      visible: false,
      disabled: true,
    };
  },
  props: {
    id: {
      type: String,
      required: true,
    },
  },
  computed: {
    ...mapGetters({
      snackbarText: 'getSnackbarText',
      showSnackbar: 'getShowSnackbar',
      user: 'getUser',
    }),
  },
  mounted() {
    getAuthenticatedUser().then((user) => {
      this.employee.uid = user.uid;
      this.employee.id = this.id;
      console.log('this is note ID', this.employee.id);
      this.employee.fetch();
    });
  },
  methods: {
    submit() {
      this.loading = true;
      this.employee.update().then(() => {
        console.log('Done creating note', this.employee.id);
        this.$store.dispatch('setSnackbarText', 'Updating Department list');
        this.$store.dispatch('setShowSnackbar', true);
        this.$router.replace({ name: 'ListEmployee' });
      });
    },
    cancel() {
      this.$router.replace({ name: 'ListEmployee' });
    },
  },
};
</script>
